Package org.apache.activemq.artemis.api.core.management

## Interface ActiveMQServerControl

-     public interface ActiveMQServerControl

  An ActiveMQServerControl is used to manage ActiveMQ Artemis servers.

- - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `static java.lang.String` | `ADDRESS_MEMORY_USAGE_DESCRIPTION` |
    `static java.lang.String` | `ADDRESS_MEMORY_USAGE_PERCENTAGE_DESCRIPTION` |
    `static java.lang.String` | `CONNECTION_COUNT_DESCRIPTION` |
    `static java.lang.String` | `DISK_STORE_USAGE_DESCRIPTION` |
    `static java.lang.String` | `TOTAL_CONNECTION_COUNT_DESCRIPTION` |

  - ### Method Summary

    All Methods Instance Methods Abstract Methods Default Methods Deprecated Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `addAddressSettings​(java.lang.String addressMatch, java.lang.String DLA, java.lang.String expiryAddress, long expiryDelay, boolean lastValueQueue, int deliveryAttempts, long maxSizeBytes, int pageSizeBytes, int pageMaxCacheSize, long redeliveryDelay, double redeliveryMultiplier, long maxRedeliveryDelay, long redistributionDelay, boolean sendToDLAOnNoRoute, java.lang.String addressFullMessagePolicy, long slowConsumerThreshold, long slowConsumerCheckPeriod, java.lang.String slowConsumerPolicy, boolean autoCreateJmsQueues, boolean autoDeleteJmsQueues, boolean autoCreateJmsTopics, boolean autoDeleteJmsTopics)` | adds a new address setting for a specific address
    `void` | `addAddressSettings​(java.lang.String addressMatch, java.lang.String DLA, java.lang.String expiryAddress, long expiryDelay, boolean lastValueQueue, int deliveryAttempts, long maxSizeBytes, int pageSizeBytes, int pageMaxCacheSize, long redeliveryDelay, double redeliveryMultiplier, long maxRedeliveryDelay, long redistributionDelay, boolean sendToDLAOnNoRoute, java.lang.String addressFullMessagePolicy, long slowConsumerThreshold, long slowConsumerCheckPeriod, java.lang.String slowConsumerPolicy, boolean autoCreateJmsQueues, boolean autoDeleteJmsQueues, boolean autoCreateJmsTopics, boolean autoDeleteJmsTopics, boolean autoCreateQueues, boolean autoDeleteQueues, boolean autoCreateAddresses, boolean autoDeleteAddresses)` | adds a new address setting for a specific address
    `void` | `addAddressSettings​(java.lang.String addressMatch, java.lang.String DLA, java.lang.String expiryAddress, long expiryDelay, boolean lastValueQueue, int deliveryAttempts, long maxSizeBytes, int pageSizeBytes, int pageMaxCacheSize, long redeliveryDelay, double redeliveryMultiplier, long maxRedeliveryDelay, long redistributionDelay, boolean sendToDLAOnNoRoute, java.lang.String addressFullMessagePolicy, long slowConsumerThreshold, long slowConsumerCheckPeriod, java.lang.String slowConsumerPolicy, boolean autoCreateJmsQueues, boolean autoDeleteJmsQueues, boolean autoCreateJmsTopics, boolean autoDeleteJmsTopics, boolean autoCreateQueues, boolean autoDeleteQueues, boolean autoCreateAddresses, boolean autoDeleteAddresses, java.lang.String configDeleteQueues, java.lang.String configDeleteAddresses, long maxSizeBytesRejectThreshold, java.lang.String defaultLastValueKey, boolean defaultNonDestructive, boolean defaultExclusiveQueue, boolean defaultGroupRebalance, int defaultGroupBuckets, java.lang.String defaultGroupFirstKey, int defaultMaxConsumers, boolean defaultPurgeOnNoConsumers, int defaultConsumersBeforeDispatch, long defaultDelayBeforeDispatch, java.lang.String defaultQueueRoutingType, java.lang.String defaultAddressRoutingType, int defaultConsumerWindowSize, long defaultRingSize, boolean autoDeleteCreatedQueues, long autoDeleteQueuesDelay, long autoDeleteQueuesMessageCount, long autoDeleteAddressesDelay, double redeliveryCollisionAvoidanceFactor, long retroactiveMessageCount)` | adds a new address setting for a specific address
    `void` | `addAddressSettings​(java.lang.String addressMatch, java.lang.String DLA, java.lang.String expiryAddress, long expiryDelay, boolean lastValueQueue, int deliveryAttempts, long maxSizeBytes, int pageSizeBytes, int pageMaxCacheSize, long redeliveryDelay, double redeliveryMultiplier, long maxRedeliveryDelay, long redistributionDelay, boolean sendToDLAOnNoRoute, java.lang.String addressFullMessagePolicy, long slowConsumerThreshold, long slowConsumerCheckPeriod, java.lang.String slowConsumerPolicy, boolean autoCreateJmsQueues, boolean autoDeleteJmsQueues, boolean autoCreateJmsTopics, boolean autoDeleteJmsTopics, boolean autoCreateQueues, boolean autoDeleteQueues, boolean autoCreateAddresses, boolean autoDeleteAddresses, java.lang.String configDeleteQueues, java.lang.String configDeleteAddresses, long maxSizeBytesRejectThreshold, java.lang.String defaultLastValueKey, boolean defaultNonDestructive, boolean defaultExclusiveQueue, boolean defaultGroupRebalance, int defaultGroupBuckets, java.lang.String defaultGroupFirstKey, int defaultMaxConsumers, boolean defaultPurgeOnNoConsumers, int defaultConsumersBeforeDispatch, long defaultDelayBeforeDispatch, java.lang.String defaultQueueRoutingType, java.lang.String defaultAddressRoutingType, int defaultConsumerWindowSize, long defaultRingSize, boolean autoDeleteCreatedQueues, long autoDeleteQueuesDelay, long autoDeleteQueuesMessageCount, long autoDeleteAddressesDelay, double redeliveryCollisionAvoidanceFactor, long retroactiveMessageCount, boolean autoCreateDeadLetterResources, java.lang.String deadLetterQueuePrefix, java.lang.String deadLetterQueueSuffix, boolean autoCreateExpiryResources, java.lang.String expiryQueuePrefix, java.lang.String expiryQueueSuffix)` | adds a new address setting for a specific address
    `void` | `addAddressSettings​(java.lang.String addressMatch, java.lang.String DLA, java.lang.String expiryAddress, long expiryDelay, boolean lastValueQueue, int maxDeliveryAttempts, long maxSizeBytes, int pageSizeBytes, int pageCacheMaxSize, long redeliveryDelay, double redeliveryMultiplier, long maxRedeliveryDelay, long redistributionDelay, boolean sendToDLAOnNoRoute, java.lang.String addressFullMessagePolicy, long slowConsumerThreshold, long slowConsumerCheckPeriod, java.lang.String slowConsumerPolicy, boolean autoCreateJmsQueues, boolean autoDeleteJmsQueues, boolean autoCreateJmsTopics, boolean autoDeleteJmsTopics, boolean autoCreateQueues, boolean autoDeleteQueues, boolean autoCreateAddresses, boolean autoDeleteAddresses, java.lang.String configDeleteQueues, java.lang.String configDeleteAddresses, long maxSizeBytesRejectThreshold, java.lang.String defaultLastValueKey, boolean defaultNonDestructive, boolean defaultExclusiveQueue, boolean defaultGroupRebalance, int defaultGroupBuckets, java.lang.String defaultGroupFirstKey, int defaultMaxConsumers, boolean defaultPurgeOnNoConsumers, int defaultConsumersBeforeDispatch, long defaultDelayBeforeDispatch, java.lang.String defaultQueueRoutingType, java.lang.String defaultAddressRoutingType, int defaultConsumerWindowSize, long defaultRingSize, boolean autoDeleteCreatedQueues, long autoDeleteQueuesDelay, long autoDeleteQueuesMessageCount, long autoDeleteAddressesDelay, double redeliveryCollisionAvoidanceFactor, long retroactiveMessageCount, boolean autoCreateDeadLetterResources, java.lang.String deadLetterQueuePrefix, java.lang.String deadLetterQueueSuffix, boolean autoCreateExpiryResources, java.lang.String expiryQueuePrefix, java.lang.String expiryQueueSuffix, long minExpiryDelay, long maxExpiryDelay, boolean enableMetrics)` | adds a new address setting for a specific address
    `void` | `addSecuritySettings​(java.lang.String addressMatch, java.lang.String sendRoles, java.lang.String consumeRoles, java.lang.String createDurableQueueRoles, java.lang.String deleteDurableQueueRoles, java.lang.String createNonDurableQueueRoles, java.lang.String deleteNonDurableQueueRoles, java.lang.String manageRoles)` |
    `void` | `addSecuritySettings​(java.lang.String addressMatch, java.lang.String sendRoles, java.lang.String consumeRoles, java.lang.String createDurableQueueRoles, java.lang.String deleteDurableQueueRoles, java.lang.String createNonDurableQueueRoles, java.lang.String deleteNonDurableQueueRoles, java.lang.String manageRoles, java.lang.String browseRoles)` |
    `void` | `addSecuritySettings​(java.lang.String addressMatch, java.lang.String sendRoles, java.lang.String consumeRoles, java.lang.String createDurableQueueRoles, java.lang.String deleteDurableQueueRoles, java.lang.String createNonDurableQueueRoles, java.lang.String deleteNonDurableQueueRoles, java.lang.String manageRoles, java.lang.String browseRoles, java.lang.String createAddressRoles, java.lang.String deleteAddressRoles)` |
    `void` | `addUser​(java.lang.String username, java.lang.String password, java.lang.String roles, boolean plaintext)` | Add a user (only applicable when using the JAAS PropertiesLoginModule or the ActiveMQBasicSecurityManager)
    `boolean` | `closeConnectionsForAddress​(java.lang.String ipAddress)` | Closes all the connections of clients connected to this server which matches the specified IP address.
    `boolean` | `closeConnectionsForUser​(java.lang.String address)` | Closes all the connections of sessions with a matching user name.
    `boolean` | `closeConnectionWithID​(java.lang.String ID)` | Closes the connection with the given id.
    `boolean` | `closeConsumerConnectionsForAddress​(java.lang.String address)` | Closes all the connections of clients connected to this server which matches the specified IP address.
    `boolean` | `closeConsumerWithID​(java.lang.String sessionID, java.lang.String ID)` | Closes the consumer with the given id.
    `boolean` | `closeSessionWithID​(java.lang.String connectionID, java.lang.String ID)` | Closes the session with the given id.
    `boolean` | `commitPreparedTransaction​(java.lang.String transactionAsBase64)` | Heuristically commits a prepared transaction.
    `java.lang.String` | `createAddress​(java.lang.String name, java.lang.String routingTypes)` |
    `void` | `createBridge​(java.lang.String bridgeConfiguration)` | Create a bridge.
    `void` | `createBridge​(java.lang.String name, java.lang.String queueName, java.lang.String forwardingAddress, java.lang.String filterString, java.lang.String transformerClassName, long retryInterval, double retryIntervalMultiplier, int initialConnectAttempts, int reconnectAttempts, boolean useDuplicateDetection, int confirmationWindowSize, int producerWindowSize, long clientFailureCheckPeriod, java.lang.String connectorNames, boolean useDiscoveryGroup, boolean ha, java.lang.String user, java.lang.String password)` | Deprecated. Deprecated in favour of `createBridge(String)`
    `void` | `createBridge​(java.lang.String name, java.lang.String queueName, java.lang.String forwardingAddress, java.lang.String filterString, java.lang.String transformerClassName, long retryInterval, double retryIntervalMultiplier, int initialConnectAttempts, int reconnectAttempts, boolean useDuplicateDetection, int confirmationWindowSize, long clientFailureCheckPeriod, java.lang.String connectorNames, boolean useDiscoveryGroup, boolean ha, java.lang.String user, java.lang.String password)` | Deprecated. Deprecated in favour of `createBridge(String)`
    `void` | `createBridge​(java.lang.String name, java.lang.String queueName, java.lang.String forwardingAddress, java.lang.String filterString, java.lang.String transformerClassName, java.lang.String transformerPropertiesAsJSON, long retryInterval, double retryIntervalMultiplier, int initialConnectAttempts, int reconnectAttempts, boolean useDuplicateDetection, int confirmationWindowSize, int producerWindowSize, long clientFailureCheckPeriod, java.lang.String connectorNames, boolean useDiscoveryGroup, boolean ha, java.lang.String user, java.lang.String password)` | Deprecated. Deprecated in favour of `createBridge(String)`
    `void` | `createBridge​(java.lang.String name, java.lang.String queueName, java.lang.String forwardingAddress, java.lang.String filterString, java.lang.String transformerClassName, java.util.Map<java.lang.String,​java.lang.String> transformerProperties, long retryInterval, double retryIntervalMultiplier, int initialConnectAttempts, int reconnectAttempts, boolean useDuplicateDetection, int confirmationWindowSize, int producerWindowSize, long clientFailureCheckPeriod, java.lang.String connectorNames, boolean useDiscoveryGroup, boolean ha, java.lang.String user, java.lang.String password)` | Deprecated. Deprecated in favour of `createBridge(String)`
    `void` | `createConnectorService​(java.lang.String name, java.lang.String factoryClass, java.util.Map<java.lang.String,​java.lang.Object> parameters)` |
    `void` | `createDivert​(java.lang.String name, java.lang.String routingName, java.lang.String address, java.lang.String forwardingAddress, boolean exclusive, java.lang.String filterString, java.lang.String transformerClassName)` |
    `void` | `createDivert​(java.lang.String name, java.lang.String routingName, java.lang.String address, java.lang.String forwardingAddress, boolean exclusive, java.lang.String filterString, java.lang.String transformerClassName, java.lang.String routingType)` |
    `void` | `createDivert​(java.lang.String name, java.lang.String routingName, java.lang.String address, java.lang.String forwardingAddress, boolean exclusive, java.lang.String filterString, java.lang.String transformerClassName, java.lang.String transformerPropertiesAsJSON, java.lang.String routingType)` |
    `void` | `createDivert​(java.lang.String name, java.lang.String routingName, java.lang.String address, java.lang.String forwardingAddress, boolean exclusive, java.lang.String filterString, java.lang.String transformerClassName, java.util.Map<java.lang.String,​java.lang.String> transformerProperties, java.lang.String routingType)` |
    `java.lang.String` | `createQueue​(java.lang.String queueConfiguration)` | Create a queue.
    `java.lang.String` | `createQueue​(java.lang.String queueConfiguration, boolean ignoreIfExists)` | Create a queue.
    `void` | `createQueue​(java.lang.String address, java.lang.String name)` | Deprecated.
    `void` | `createQueue​(java.lang.String address, java.lang.String name, boolean durable)` | Deprecated.
    `void` | `createQueue​(java.lang.String address, java.lang.String name, boolean durable, java.lang.String routingType)` | Deprecated.
    `void` | `createQueue​(java.lang.String address, java.lang.String name, java.lang.String routingType)` | Deprecated.
    `void` | `createQueue​(java.lang.String address, java.lang.String name, java.lang.String filter, boolean durable)` | Deprecated.
    `void` | `createQueue​(java.lang.String address, java.lang.String name, java.lang.String filter, boolean durable, java.lang.String routingType)` | Deprecated.
    `java.lang.String` | `createQueue​(java.lang.String address, java.lang.String routingType, java.lang.String name, java.lang.String filterStr, boolean durable, int maxConsumers, boolean purgeOnNoConsumers, boolean autoCreateAddress)` | Deprecated.
    `java.lang.String` | `createQueue​(java.lang.String address, java.lang.String routingType, java.lang.String name, java.lang.String filterStr, boolean durable, int maxConsumers, boolean purgeOnNoConsumers, boolean exclusive, boolean groupRebalance, int groupBuckets, boolean lastValue, java.lang.String lastValueKey, boolean nonDestructive, int consumersBeforeDispatch, long delayBeforeDispatch, boolean autoCreateAddress)` | Deprecated.
    `java.lang.String` | `createQueue​(java.lang.String address, java.lang.String routingType, java.lang.String name, java.lang.String filterStr, boolean durable, int maxConsumers, boolean purgeOnNoConsumers, boolean exclusive, boolean groupRebalance, int groupBuckets, boolean lastValue, java.lang.String lastValueKey, boolean nonDestructive, int consumersBeforeDispatch, long delayBeforeDispatch, boolean autoDelete, long autoDeleteDelay, long autoDeleteMessageCount, boolean autoCreateAddress)` | Deprecated.
    `java.lang.String` | `createQueue​(java.lang.String address, java.lang.String routingType, java.lang.String name, java.lang.String filterStr, boolean durable, int maxConsumers, boolean purgeOnNoConsumers, boolean exclusive, boolean groupRebalance, int groupBuckets, java.lang.String groupFirstKey, boolean lastValue, java.lang.String lastValueKey, boolean nonDestructive, int consumersBeforeDispatch, long delayBeforeDispatch, boolean autoDelete, long autoDeleteDelay, long autoDeleteMessageCount, boolean autoCreateAddress)` | Deprecated.
    `java.lang.String` | `createQueue​(java.lang.String address, java.lang.String routingType, java.lang.String name, java.lang.String filterStr, boolean durable, int maxConsumers, boolean purgeOnNoConsumers, boolean exclusive, boolean groupRebalance, int groupBuckets, java.lang.String groupFirstKey, boolean lastValue, java.lang.String lastValueKey, boolean nonDestructive, int consumersBeforeDispatch, long delayBeforeDispatch, boolean autoDelete, long autoDeleteDelay, long autoDeleteMessageCount, boolean autoCreateAddress, long ringSize)` | Deprecated.
    `void` | `deleteAddress​(java.lang.String name)` |
    `void` | `deleteAddress​(java.lang.String name, boolean force)` |
    `void` | `deployQueue​(java.lang.String address, java.lang.String name, java.lang.String filter)` | Deprecated.
    `void` | `deployQueue​(java.lang.String address, java.lang.String name, java.lang.String filter, boolean durable)` | Deprecated.
    `void` | `destroyBridge​(java.lang.String name)` |
    `void` | `destroyConnectorService​(java.lang.String name)` |
    `void` | `destroyDivert​(java.lang.String name)` |
    `void` | `destroyQueue​(java.lang.String name)` | Destroys the queue corresponding to the specified name.
    `void` | `destroyQueue​(java.lang.String name, boolean removeConsumers)` | Destroys the queue corresponding to the specified name.
    `void` | `destroyQueue​(java.lang.String name, boolean removeConsumers, boolean autoDeleteAddress)` | Destroys the queue corresponding to the specified name and delete it's address if there are no other queues
    `void` | `disableMessageCounters()` | Disables message counters for this server.
    `void` | `enableMessageCounters()` | Enables message counters for this server.
    `void` | `forceFailover()` |
    `boolean` | `freezeReplication()` |
    `java.lang.Object[]` | `getAcceptors()` | Returns the acceptors configured for this server.
    `java.lang.String` | `getAcceptorsAsJSON()` | Returns the acceptors configured for this server using JSON serialization.
    `long` | `getActivationSequence()` | Returns the current activation sequence number of this server.
    `int` | `getAddressCount()` | Returns the number of addresses created on this server.
    `java.lang.String` | `getAddressInfo​(java.lang.String address)` |
    `long` | `getAddressMemoryUsage()` | Returns the memory used by all the addresses on broker for in-memory messages
    `int` | `getAddressMemoryUsagePercentage()` | Returns the memory used by all the addresses on broker as a percentage of the global-max-size
    `java.lang.String[]` | `getAddressNames()` | Returns the names of the addresses created on this server.
    `java.lang.String` | `getAddressSettingsAsJSON​(java.lang.String addressMatch)` | returns the address settings as a JSON string
    `long` | `getAuthenticationCacheSize()` | Returns the runtime size of the authentication cache
    `long` | `getAuthorizationCacheSize()` | Returns the runtime size of the authorization cache
    `java.lang.String` | `getBindingsDirectory()` | Returns the file system directory used to store bindings.
    `java.lang.String[]` | `getBridgeNames()` |
    `java.lang.String[]` | `getClusterConnectionNames()` | Returns the names of the cluster-connections deployed on this server.
    `int` | `getConnectionCount()` | Returns the number of clients connected to this server.
    `long` | `getConnectionTTLOverride()` | Returns the connection time to live.
    `java.lang.Object[]` | `getConnectors()` | Returns the connectors configured for this server.
    `java.lang.String` | `getConnectorsAsJSON()` | Returns the connectors configured for this server using JSON serialization.
    `java.lang.String[]` | `getConnectorServices()` |
    `int` | `getDiskScanPeriod()` | Returns how often the server checks for disk space usage.
    `double` | `getDiskStoreUsage()` | Returns the percentage of total disk store use
    `java.lang.String[]` | `getDivertNames()` |
    `long` | `getGlobalMaxSize()` | Returns the global max bytes limit for in-memory messages.
    `java.lang.String` | `getHAPolicy()` |
    `int` | `getIDCacheSize()` | Returns the size of the cache for pre-creating message IDs.
    `java.lang.String[]` | `getIncomingInterceptorClassNames()` | Returns the list of interceptors used by this server for incoming messages.
    `int` | `getJournalBufferSize()` | Returns the size of the internal buffer on the journal.
    `int` | `getJournalBufferTimeout()` | Returns the timeout (in nanoseconds) used to flush internal buffers on the journal.
    `int` | `getJournalCompactMinFiles()` | Returns the minimal number of journal files before compacting.
    `int` | `getJournalCompactPercentage()` | Return the percentage of live data before compacting the journal.
    `java.lang.String` | `getJournalDirectory()` | Returns the file system directory used to store journal log.
    `int` | `getJournalFileSize()` | Returns the size (in bytes) of each journal files.
    `int` | `getJournalMaxIO()` | Returns the maximum number of write requests that can be in the AIO queue at any given time.
    `int` | `getJournalMinFiles()` | Returns the number of journal files to pre-create.
    `int` | `getJournalPoolFiles()` | Number of files that would be acceptable to keep on a pool
    `java.lang.String` | `getJournalType()` | Returns the type of journal used by this server (either `NIO` or `ASYNCIO`).
    `java.lang.String` | `getLargeMessagesDirectory()` | Returns the file system directory used to store large messages.
    `java.lang.String` | `getManagementAddress()` | Returns the management address of this server.
    `java.lang.String` | `getManagementNotificationAddress()` | Returns the management notification address of this server.
    `int` | `getMaxDiskUsage()` | Returns the disk use max limit.
    `int` | `getMessageCounterMaxDayCount()` | Returns the maximum number of days kept in memory for message counter.
    `long` | `getMessageCounterSamplePeriod()` | Returns the sample period (in milliseconds) to take message counter snapshot.
    `long` | `getMessageExpiryScanPeriod()` | Returns the frequency (in milliseconds) to scan messages to detect which messages have expired.
    `long` | `getMessageExpiryThreadPriority()` | Deprecated.
    `java.lang.String` | `getName()` | Returns this server's name.
    `java.lang.String` | `getNodeID()` | Returns the node ID of this server.
    `java.lang.String[]` | `getOutgoingInterceptorClassNames()` | Returns the list of interceptors used by this server for outgoing messages.
    `java.lang.String` | `getPagingDirectory()` | Returns the file system directory used to store paging files.
    `int` | `getQueueCount()` | Returns the number of queues created on this server.
    `java.lang.String[]` | `getQueueNames()` | Returns the names of the queues created on this server.
    `java.lang.String[]` | `getQueueNames​(java.lang.String routingType)` | Returns the names of the queues created on this server with the given routing-type.
    `java.lang.Object[]` | `getRoles​(java.lang.String addressMatch)` |
    `java.lang.String` | `getRolesAsJSON​(java.lang.String addressMatch)` |
    `int` | `getScheduledThreadPoolMaxSize()` | Returns the maximum number of threads in the scheduled thread pool.
    `long` | `getSecurityInvalidationInterval()` | Returns the interval time (in milliseconds) to invalidate security credentials.
    `int` | `getThreadPoolMaxSize()` | Returns the maximum number of threads in the thread pool.
    `long` | `getTotalConnectionCount()` | Returns the number of clients which have connected to this server since it was started.
    `long` | `getTotalConsumerCount()` | Returns the number of messages sent to this server since it was started.
    `long` | `getTotalMessageCount()` | Returns the number of messages in all queues on the server.
    `long` | `getTotalMessagesAcknowledged()` | Returns the number of messages sent to this server since it was started.
    `long` | `getTotalMessagesAdded()` | Returns the number of messages sent to this server since it was started.
    `long` | `getTransactionTimeout()` | Returns the timeout (in milliseconds) after which transactions is removed from the resource manager after it was created.
    `long` | `getTransactionTimeoutScanPeriod()` | Returns the frequency (in milliseconds) to scan transactions to detect which transactions have timed out.
    `java.lang.String` | `getUptime()` | Returns the uptime of this server.
    `long` | `getUptimeMillis()` | Returns the uptime of this server.
    `java.lang.String` | `getVersion()` | Returns this server's version.
    `boolean` | `isActive()` |
    `boolean` | `isAsyncConnectionExecutionEnabled()` | Returns whether code coming from connection is executed asynchronously or not.
    `boolean` | `isBackup()` | Returns `true` if this server is a backup, `false` if it is a live server.
    `boolean` | `isClustered()` | Returns whether this server is clustered.
    `boolean` | `isCreateBindingsDir()` | Returns whether the bindings directory is created on this server startup.
    `boolean` | `isCreateJournalDir()` | Returns whether the journal directory is created on this server startup.
    `boolean` | `isEmbeddedWebServerStarted()` |
    `boolean` | `isFailoverOnServerShutdown()` | returns if clients failover on a server shutdown
    `boolean` | `isJournalSyncNonTransactional()` | Returns whether the journal is synchronized when receiving non-transactional data.
    `boolean` | `isJournalSyncTransactional()` | Returns whether the journal is synchronized when receiving transactional data.
    `boolean` | `isMessageCounterEnabled()` | Returns whether message counter is enabled for this server.
    `boolean` | `isPersistDeliveryCountBeforeDelivery()` | Returns whether delivery count is persisted before messages are delivered to the consumers.
    `boolean` | `isPersistenceEnabled()` | Returns whether this server is using persistence and store data.
    `boolean` | `isPersistIDCache()` | Returns whether message ID cache is persisted.
    `boolean` | `isReplicaSync()` | Returns whether the initial replication synchronization process with the backup server is complete; applicable for either the live or backup server.
    `boolean` | `isSecurityEnabled()` | Returns whether security is enabled for this server.
    `boolean` | `isSharedStore()` | Returns whether this server shares its data store with a corresponding live or backup server.
    `boolean` | `isStarted()` | Return whether this server is started.
    `boolean` | `isWildcardRoutingEnabled()` | Returns whether wildcard routing is supported by this server.
    `java.lang.String` | `listAddresses​(java.lang.String separator)` |
    `java.lang.String` | `listAddresses​(java.lang.String options, int page, int pageSize)` |
    `java.lang.String` | `listAllConsumersAsJSON()` | Lists all the consumers connected to this server.
    `java.lang.String` | `listAllSessionsAsJSON()` | Lists details about all sessions.
    `java.lang.String` | `listBindingsForAddress​(java.lang.String address)` |
    `java.lang.String` | `listBrokerConnections()` |
    `java.lang.String[]` | `listConnectionIDs()` | Lists all the IDs of the connections connected to this server.
    `java.lang.String` | `listConnections​(java.lang.String options, int page, int pageSize)` |
    `java.lang.String` | `listConnectionsAsJSON()` | Lists all the connections connected to this server.
    `java.lang.String` | `listConsumers​(java.lang.String options, int page, int pageSize)` |
    `java.lang.String` | `listConsumersAsJSON​(java.lang.String connectionID)` | Lists all the consumers which belongs to the connection specified by the connectionID.
    `default java.lang.String[]` | `listDivertNames()` | Jon plugin doesn't recognize an Operation whose name is in form getXXXX(), so add this one.
    `java.lang.String[]` | `listHeuristicCommittedTransactions()` | List transactions which have been heuristically committed.
    `java.lang.String[]` | `listHeuristicRolledBackTransactions()` | List transactions which have been heuristically rolled back.
    `java.lang.String` | `listNetworkTopology()` |
    `java.lang.String` | `listPreparedTransactionDetailsAsHTML()` | Deprecated.
    `java.lang.String` | `listPreparedTransactionDetailsAsJSON()` | List all the prepared transaction, sorted by date, oldest first, with details, in text format.
    `java.lang.String[]` | `listPreparedTransactions()` | List all the prepared transaction, sorted by date, oldest first.
    `java.lang.String` | `listProducers​(java.lang.String options, int page, int pageSize)` |
    `java.lang.String` | `listProducersInfoAsJSON()` |
    `java.lang.String` | `listQueues​(java.lang.String options, int page, int pageSize)` |
    `java.lang.String[]` | `listRemoteAddresses()` | Lists the addresses of all the clients connected to this address.
    `java.lang.String[]` | `listRemoteAddresses​(java.lang.String ipAddress)` | Lists the addresses of the clients connected to this address which matches the specified IP address.
    `java.lang.String[]` | `listSessions​(java.lang.String connectionID)` | Lists all the sessions IDs for the specified connection ID.
    `java.lang.String` | `listSessions​(java.lang.String options, int page, int pageSize)` |
    `java.lang.String` | `listSessionsAsJSON​(java.lang.String connectionID)` | Lists details about all the sessions for the specified connection ID.
    `java.lang.String` | `listUser​(java.lang.String username)` | List the information about a user or all users if no username is supplied (only applicable when using the JAAS PropertiesLoginModule or the ActiveMQBasicSecurityManager).
    `void` | `reloadConfigurationFile()` |
    `void` | `removeAddressSettings​(java.lang.String addressMatch)` |
    `void` | `removeSecuritySettings​(java.lang.String addressMatch)` |
    `void` | `removeUser​(java.lang.String username)` | Remove a user (only applicable when using the JAAS PropertiesLoginModule or the ActiveMQBasicSecurityManager).
    `void` | `replay​(java.lang.String address, java.lang.String target, java.lang.String filter)` |
    `void` | `replay​(java.lang.String startScan, java.lang.String endScan, java.lang.String address, java.lang.String target, java.lang.String filter)` |
    `void` | `resetAllMessageCounterHistories()` | Reset histories for all message counters.
    `void` | `resetAllMessageCounters()` | Reset all message counters.
    `void` | `resetUser​(java.lang.String username, java.lang.String password, java.lang.String roles)` | Set new properties on an existing user (only applicable when using the JAAS PropertiesLoginModule or the ActiveMQBasicSecurityManager).
    `void` | `resetUser​(java.lang.String username, java.lang.String password, java.lang.String roles, boolean plaintext)` | Set new properties on an existing user (only applicable when using the JAAS PropertiesLoginModule or the ActiveMQBasicSecurityManager).
    `void` | `restartEmbeddedWebServer()` |
    `void` | `restartEmbeddedWebServer​(long timeout)` |
    `boolean` | `rollbackPreparedTransaction​(java.lang.String transactionAsBase64)` | Heuristically rolls back a prepared transaction.
    `void` | `scaleDown​(java.lang.String connector)` |
    `void` | `setFailoverOnServerShutdown​(boolean failoverOnServerShutdown)` | do any clients failover on a server shutdown
    `void` | `setMessageCounterMaxDayCount​(int count)` | Sets the maximum number of days kept in memory for message counter.
    `void` | `setMessageCounterSamplePeriod​(long newPeriod)` | Sets the sample period to take message counter snapshot.
    `void` | `startBrokerConnection​(java.lang.String name)` |
    `void` | `startEmbeddedWebServer()` |
    `void` | `stopBrokerConnection​(java.lang.String name)` |
    `void` | `stopEmbeddedWebServer()` |
    `java.lang.String` | `updateAddress​(java.lang.String name, java.lang.String routingTypes)` |
    `void` | `updateDivert​(java.lang.String name, java.lang.String forwardingAddress, java.lang.String filterString, java.lang.String transformerClassName, java.util.Map<java.lang.String,​java.lang.String> transformerProperties, java.lang.String routingType)` | update a divert
    `java.lang.String` | `updateQueue​(java.lang.String queueConfiguration)` | Update a queue.
    `java.lang.String` | `updateQueue​(java.lang.String name, java.lang.String routingType, java.lang.Integer maxConsumers, java.lang.Boolean purgeOnNoConsumers)` | Deprecated.
    `java.lang.String` | `updateQueue​(java.lang.String name, java.lang.String routingType, java.lang.Integer maxConsumers, java.lang.Boolean purgeOnNoConsumers, java.lang.Boolean exclusive)` | Deprecated.
    `java.lang.String` | `updateQueue​(java.lang.String name, java.lang.String routingType, java.lang.Integer maxConsumers, java.lang.Boolean purgeOnNoConsumers, java.lang.Boolean exclusive, java.lang.String user)` | Deprecated.
    `java.lang.String` | `updateQueue​(java.lang.String name, java.lang.String routingType, java.lang.String filter, java.lang.Integer maxConsumers, java.lang.Boolean purgeOnNoConsumers, java.lang.Boolean exclusive, java.lang.Boolean groupRebalance, java.lang.Integer groupBuckets, java.lang.Boolean nonDestructive, java.lang.Integer consumersBeforeDispatch, java.lang.Long delayBeforeDispatch, java.lang.String user)` | Deprecated.
    `java.lang.String` | `updateQueue​(java.lang.String name, java.lang.String routingType, java.lang.String filter, java.lang.Integer maxConsumers, java.lang.Boolean purgeOnNoConsumers, java.lang.Boolean exclusive, java.lang.Boolean groupRebalance, java.lang.Integer groupBuckets, java.lang.String groupFirstKey, java.lang.Boolean nonDestructive, java.lang.Integer consumersBeforeDispatch, java.lang.Long delayBeforeDispatch, java.lang.String user)` | Deprecated.
    `java.lang.String` | `updateQueue​(java.lang.String name, java.lang.String routingType, java.lang.String filter, java.lang.Integer maxConsumers, java.lang.Boolean purgeOnNoConsumers, java.lang.Boolean exclusive, java.lang.Boolean groupRebalance, java.lang.Integer groupBuckets, java.lang.String groupFirstKey, java.lang.Boolean nonDestructive, java.lang.Integer consumersBeforeDispatch, java.lang.Long delayBeforeDispatch, java.lang.String user, java.lang.Long ringSize)` | Deprecated.

- - ### Field Detail

    - #### CONNECTION_COUNT_DESCRIPTION

          static final java.lang.String CONNECTION_COUNT_DESCRIPTION

      See Also:
        Constant Field Values

    - #### TOTAL_CONNECTION_COUNT_DESCRIPTION

          static final java.lang.String TOTAL_CONNECTION_COUNT_DESCRIPTION

      See Also:
        Constant Field Values

    - #### ADDRESS_MEMORY_USAGE_DESCRIPTION

          static final java.lang.String ADDRESS_MEMORY_USAGE_DESCRIPTION

      See Also:
        Constant Field Values

    - #### ADDRESS_MEMORY_USAGE_PERCENTAGE_DESCRIPTION

          static final java.lang.String ADDRESS_MEMORY_USAGE_PERCENTAGE_DESCRIPTION

      See Also:
        Constant Field Values

    - #### DISK_STORE_USAGE_DESCRIPTION

          static final java.lang.String DISK_STORE_USAGE_DESCRIPTION

      See Also:
        Constant Field Values

  - ### Method Detail

    - #### getName

          java.lang.String getName()

      Returns this server's name.

    - #### getVersion

          java.lang.String getVersion()

      Returns this server's version.

    - #### isActive

          boolean isActive()

    - #### getConnectionCount

          int getConnectionCount()

      Returns the number of clients connected to this server.

    - #### getTotalConnectionCount

          long getTotalConnectionCount()

      Returns the number of clients which have connected to this server since it was started.

    - #### getTotalMessageCount

          long getTotalMessageCount()

      Returns the number of messages in all queues on the server.

    - #### getTotalMessagesAdded

          long getTotalMessagesAdded()

      Returns the number of messages sent to this server since it was started.

    - #### getTotalMessagesAcknowledged

          long getTotalMessagesAcknowledged()

      Returns the number of messages sent to this server since it was started.

    - #### getTotalConsumerCount

          long getTotalConsumerCount()

      Returns the number of messages sent to this server since it was started.

    - #### isStarted

          boolean isStarted()

      Return whether this server is started.

    - #### getIncomingInterceptorClassNames

          java.lang.String[] getIncomingInterceptorClassNames()

      Returns the list of interceptors used by this server for incoming messages.
      See Also:
        `Interceptor`

    - #### getOutgoingInterceptorClassNames

          java.lang.String[] getOutgoingInterceptorClassNames()

      Returns the list of interceptors used by this server for outgoing messages.
      See Also:
        `Interceptor`

    - #### isClustered

          boolean isClustered()

      Returns whether this server is clustered.

    - #### getScheduledThreadPoolMaxSize

          int getScheduledThreadPoolMaxSize()

      Returns the maximum number of threads in the scheduled thread pool.

    - #### getThreadPoolMaxSize

          int getThreadPoolMaxSize()

      Returns the maximum number of threads in the thread pool.

    - #### getSecurityInvalidationInterval

          long getSecurityInvalidationInterval()

      Returns the interval time (in milliseconds) to invalidate security credentials.

    - #### isSecurityEnabled

          boolean isSecurityEnabled()

      Returns whether security is enabled for this server.

    - #### getBindingsDirectory

          java.lang.String getBindingsDirectory()

      Returns the file system directory used to store bindings.

    - #### getJournalDirectory

          java.lang.String getJournalDirectory()

      Returns the file system directory used to store journal log.

    - #### getJournalType

          java.lang.String getJournalType()

      Returns the type of journal used by this server (either `NIO` or `ASYNCIO`).

    - #### isJournalSyncTransactional

          boolean isJournalSyncTransactional()

      Returns whether the journal is synchronized when receiving transactional data.

    - #### isJournalSyncNonTransactional

          boolean isJournalSyncNonTransactional()

      Returns whether the journal is synchronized when receiving non-transactional data.

    - #### getJournalFileSize

          int getJournalFileSize()

      Returns the size (in bytes) of each journal files.

    - #### getJournalMinFiles

          int getJournalMinFiles()

      Returns the number of journal files to pre-create.

    - #### getJournalMaxIO

          int getJournalMaxIO()

      Returns the maximum number of write requests that can be in the AIO queue at any given time.

    - #### getJournalBufferSize

          int getJournalBufferSize()

      Returns the size of the internal buffer on the journal.

    - #### getJournalPoolFiles

          int getJournalPoolFiles()

      Number of files that would be acceptable to keep on a pool

    - #### getJournalBufferTimeout

          int getJournalBufferTimeout()

      Returns the timeout (in nanoseconds) used to flush internal buffers on the journal.

    - #### setFailoverOnServerShutdown

          void setFailoverOnServerShutdown​(boolean failoverOnServerShutdown)
                                    throws java.lang.Exception

      do any clients failover on a server shutdown
      Throws:
        `java.lang.Exception`

    - #### isFailoverOnServerShutdown

          boolean isFailoverOnServerShutdown()

      returns if clients failover on a server shutdown

    - #### getJournalCompactMinFiles

          int getJournalCompactMinFiles()

      Returns the minimal number of journal files before compacting.

    - #### getJournalCompactPercentage

          int getJournalCompactPercentage()

      Return the percentage of live data before compacting the journal.

    - #### isPersistenceEnabled

          boolean isPersistenceEnabled()

      Returns whether this server is using persistence and store data.

    - #### isCreateBindingsDir

          boolean isCreateBindingsDir()

      Returns whether the bindings directory is created on this server startup.

    - #### isCreateJournalDir

          boolean isCreateJournalDir()

      Returns whether the journal directory is created on this server startup.

    - #### isMessageCounterEnabled

          boolean isMessageCounterEnabled()

      Returns whether message counter is enabled for this server.

    - #### getMessageCounterMaxDayCount

          int getMessageCounterMaxDayCount()

      Returns the maximum number of days kept in memory for message counter.

    - #### setMessageCounterMaxDayCount

          void setMessageCounterMaxDayCount​(int count)
                                     throws java.lang.Exception

      Sets the maximum number of days kept in memory for message counter.
      Parameters:
        `count` - value must be greater than 0
      Throws:
        `java.lang.Exception`

    - #### getMessageCounterSamplePeriod

          long getMessageCounterSamplePeriod()

      Returns the sample period (in milliseconds) to take message counter snapshot.

    - #### setMessageCounterSamplePeriod

          void setMessageCounterSamplePeriod​(long newPeriod)
                                      throws java.lang.Exception

      Sets the sample period to take message counter snapshot.
      Parameters:
        `newPeriod` - value must be greater than 1000ms
      Throws:
        `java.lang.Exception`

    - #### isBackup

          boolean isBackup()

      Returns `true` if this server is a backup, `false` if it is a live server.
      If a backup server has been activated, returns `false`.

    - #### isSharedStore

          boolean isSharedStore()

      Returns whether this server shares its data store with a corresponding live or backup server.

    - #### getPagingDirectory

          java.lang.String getPagingDirectory()

      Returns the file system directory used to store paging files.

    - #### isPersistDeliveryCountBeforeDelivery

          boolean isPersistDeliveryCountBeforeDelivery()

      Returns whether delivery count is persisted before messages are delivered to the consumers.

    - #### getConnectionTTLOverride

          long getConnectionTTLOverride()

      Returns the connection time to live.
      This value overrides the connection time to live sent by the client.

    - #### getManagementAddress

          java.lang.String getManagementAddress()

      Returns the management address of this server.
      Clients can send management messages to this address to manage this server.

    - #### getNodeID

          java.lang.String getNodeID()

      Returns the node ID of this server.
      Clients can send management messages to this address to manage this server.

    - #### getActivationSequence

          long getActivationSequence()

      Returns the current activation sequence number of this server.
      When replicated, peers may coordinate activation with this monotonic sequence

    - #### getManagementNotificationAddress

          java.lang.String getManagementNotificationAddress()

      Returns the management notification address of this server.
      Clients can bind queues to this address to receive management notifications emitted by this server.

    - #### getIDCacheSize

          int getIDCacheSize()

      Returns the size of the cache for pre-creating message IDs.

    - #### isPersistIDCache

          boolean isPersistIDCache()

      Returns whether message ID cache is persisted.

    - #### getLargeMessagesDirectory

          java.lang.String getLargeMessagesDirectory()

      Returns the file system directory used to store large messages.

    - #### isWildcardRoutingEnabled

          boolean isWildcardRoutingEnabled()

      Returns whether wildcard routing is supported by this server.

    - #### getTransactionTimeout

          long getTransactionTimeout()

      Returns the timeout (in milliseconds) after which transactions is removed from the resource manager after it was created.

    - #### getTransactionTimeoutScanPeriod

          long getTransactionTimeoutScanPeriod()

      Returns the frequency (in milliseconds) to scan transactions to detect which transactions have timed out.

    - #### getMessageExpiryScanPeriod

          long getMessageExpiryScanPeriod()

      Returns the frequency (in milliseconds) to scan messages to detect which messages have expired.

    - #### getMessageExpiryThreadPriority

          @Deprecated
          long getMessageExpiryThreadPriority()

      Deprecated.
      Returns the priority of the thread used to scan message expiration.

    - #### isAsyncConnectionExecutionEnabled

          boolean isAsyncConnectionExecutionEnabled()

      Returns whether code coming from connection is executed asynchronously or not.

    - #### getConnectors

          java.lang.Object[] getConnectors()
                                    throws java.lang.Exception

      Returns the connectors configured for this server.
      Throws:
        `java.lang.Exception`

    - #### getConnectorsAsJSON

          java.lang.String getConnectorsAsJSON()
                                        throws java.lang.Exception

      Returns the connectors configured for this server using JSON serialization.
      Throws:
        `java.lang.Exception`

    - #### getAcceptors

          java.lang.Object[] getAcceptors()
                                   throws java.lang.Exception

      Returns the acceptors configured for this server.
      Throws:
        `java.lang.Exception`

    - #### getAcceptorsAsJSON

          java.lang.String getAcceptorsAsJSON()
                                       throws java.lang.Exception

      Returns the acceptors configured for this server using JSON serialization.
      Throws:
        `java.lang.Exception`

    - #### getAddressCount

          int getAddressCount()

      Returns the number of addresses created on this server.

    - #### getAddressNames

          java.lang.String[] getAddressNames()

      Returns the names of the addresses created on this server.

    - #### getQueueCount

          int getQueueCount()

      Returns the number of queues created on this server.

    - #### getQueueNames

          java.lang.String[] getQueueNames()

      Returns the names of the queues created on this server.

    - #### getUptime

          java.lang.String getUptime()

      Returns the uptime of this server.

    - #### getUptimeMillis

          long getUptimeMillis()

      Returns the uptime of this server.

    - #### isReplicaSync

          boolean isReplicaSync()

      Returns whether the initial replication synchronization process with the backup server is complete; applicable for either the live or backup server.

    - #### getDiskScanPeriod

          int getDiskScanPeriod()

      Returns how often the server checks for disk space usage.

    - #### getMaxDiskUsage

          int getMaxDiskUsage()

      Returns the disk use max limit.

    - #### getGlobalMaxSize

          long getGlobalMaxSize()

      Returns the global max bytes limit for in-memory messages.

    - #### getAddressMemoryUsage

          long getAddressMemoryUsage()

      Returns the memory used by all the addresses on broker for in-memory messages

    - #### getDiskStoreUsage

          double getDiskStoreUsage()

      Returns the percentage of total disk store use

    - #### getAddressMemoryUsagePercentage

          int getAddressMemoryUsagePercentage()

      Returns the memory used by all the addresses on broker as a percentage of the global-max-size

    - #### getHAPolicy

          java.lang.String getHAPolicy()

    - #### getAuthenticationCacheSize

          long getAuthenticationCacheSize()

      Returns the runtime size of the authentication cache

    - #### getAuthorizationCacheSize

          long getAuthorizationCacheSize()

      Returns the runtime size of the authorization cache

    - #### freezeReplication

          boolean freezeReplication()

    - #### createAddress

          java.lang.String createAddress​(java.lang.String name,
                                         java.lang.String routingTypes)
                                  throws java.lang.Exception

      Throws:
        `java.lang.Exception`

    - #### updateAddress

          java.lang.String updateAddress​(java.lang.String name,
                                         java.lang.String routingTypes)
                                  throws java.lang.Exception

      Throws:
        `java.lang.Exception`

    - #### deleteAddress

          void deleteAddress​(java.lang.String name)
                      throws java.lang.Exception

      Throws:
        `java.lang.Exception`

    - #### deleteAddress

          void deleteAddress​(java.lang.String name,
                             boolean force)
                      throws java.lang.Exception

      Throws:
        `java.lang.Exception`

    - #### createQueue

          @Deprecated
          void createQueue​(java.lang.String address,
                           java.lang.String name)
                    throws java.lang.Exception

      Deprecated.
      Create a durable queue.
      If `address` is `null` it will be defaulted to `name`.
      This method throws a `ActiveMQQueueExistsException`) exception if the queue already exits.
      Parameters:
        `address` - address to bind the queue to
        `name` - name of the queue
      Throws:
        `java.lang.Exception`

    - #### createQueue

          @Deprecated
          void createQueue​(java.lang.String address,
                           java.lang.String name,
                           java.lang.String routingType)
                    throws java.lang.Exception

      Deprecated.
      Create a durable queue.
      If `address` is `null` it will be defaulted to `name`.
      This method throws a `ActiveMQQueueExistsException`) exception if the queue already exits.
      Parameters:
        `address` - address to bind the queue to
        `name` - name of the queue
        `routingType` - The routing type used for this address, MULTICAST or ANYCAST
      Throws:
        `java.lang.Exception`

    - #### createQueue

          @Deprecated
          void createQueue​(java.lang.String address,
                           java.lang.String name,
                           boolean durable)
                    throws java.lang.Exception

      Deprecated.
      Create a queue.
      If `address` is `null` it will be defaulted to `name`.
      This method throws a `ActiveMQQueueExistsException`) exception if the queue already exits.
      Parameters:
        `address` - address to bind the queue to
        `name` - name of the queue
        `durable` - whether the queue is durable
      Throws:
        `java.lang.Exception`

    - #### createQueue

          @Deprecated
          void createQueue​(java.lang.String address,
                           java.lang.String name,
                           boolean durable,
                           java.lang.String routingType)
                    throws java.lang.Exception

      Deprecated.
      Create a queue.
      If `address` is `null` it will be defaulted to `name`.
      This method throws a `ActiveMQQueueExistsException`) exception if the queue already exits.
      Parameters:
        `address` - address to bind the queue to
        `name` - name of the queue
        `durable` - whether the queue is durable
        `routingType` - The routing type used for this address, MULTICAST or ANYCAST
      Throws:
        `java.lang.Exception`

    - #### createQueue

          @Deprecated
          void createQueue​(java.lang.String address,
                           java.lang.String name,
                           java.lang.String filter,
                           boolean durable)
                    throws java.lang.Exception

      Deprecated.
      Create a queue.
      If `address` is `null` it will be defaulted to `name`.
      This method throws a `ActiveMQQueueExistsException`) exception if the queue already exits.
      Parameters:
        `address` - address to bind the queue to
        `name` - name of the queue
        `filter` - of the queue
        `durable` - whether the queue is durable
      Throws:
        `java.lang.Exception`

    - #### createQueue

          @Deprecated
          void createQueue​(java.lang.String address,
                           java.lang.String name,
                           java.lang.String filter,
                           boolean durable,
                           java.lang.String routingType)
                    throws java.lang.Exception

      Deprecated.
      Create a queue.
      If `address` is `null` it will be defaulted to `name`.
      This method throws a `ActiveMQQueueExistsException`) exception if the queue already exits.
      Parameters:
        `address` - address to bind the queue to
        `name` - name of the queue
        `filter` - of the queue
        `durable` - whether the queue is durable
        `routingType` - The routing type used for this address, MULTICAST or ANYCAST
      Throws:
        `java.lang.Exception`

    - #### createQueue

          @Deprecated
          java.lang.String createQueue​(java.lang.String address,
                                       java.lang.String routingType,
                                       java.lang.String name,
                                       java.lang.String filterStr,
                                       boolean durable,
                                       int maxConsumers,
                                       boolean purgeOnNoConsumers,
                                       boolean exclusive,
                                       boolean groupRebalance,
                                       int groupBuckets,
                                       boolean lastValue,
                                       java.lang.String lastValueKey,
                                       boolean nonDestructive,
                                       int consumersBeforeDispatch,
                                       long delayBeforeDispatch,
                                       boolean autoCreateAddress)
                                throws java.lang.Exception

      Deprecated.
      Create a queue.
      If `address` is `null` it will be defaulted to `name`.
      This method throws a `ActiveMQQueueExistsException`) exception if the queue already exits.
      Parameters:
        `address` - address to bind the queue to
        `routingType` - the routing type used for this address, `MULTICAST` or `ANYCAST`
        `name` - name of the queue
        `filterStr` - filter of the queue
        `durable` - is the queue durable?
        `maxConsumers` - the maximum number of consumers allowed on this queue at any one time
        `purgeOnNoConsumers` - delete this queue when the last consumer disconnects
        `exclusive` - if the queue should route exclusively to one consumer
        `lastValue` - use last-value semantics
        `consumersBeforeDispatch` - number of consumers needed before dispatch can start
        `delayBeforeDispatch` - delay to wait before dispatching if number of consumers before dispatch is not met
        `autoCreateAddress` - create an address with default values should a matching address not be found
      Returns:
        a textual summary of the queue
      Throws:
        `java.lang.Exception`

    - #### createQueue

          @Deprecated
          java.lang.String createQueue​(java.lang.String address,
                                       java.lang.String routingType,
                                       java.lang.String name,
                                       java.lang.String filterStr,
                                       boolean durable,
                                       int maxConsumers,
                                       boolean purgeOnNoConsumers,
                                       boolean exclusive,
                                       boolean groupRebalance,
                                       int groupBuckets,
                                       boolean lastValue,
                                       java.lang.String lastValueKey,
                                       boolean nonDestructive,
                                       int consumersBeforeDispatch,
                                       long delayBeforeDispatch,
                                       boolean autoDelete,
                                       long autoDeleteDelay,
                                       long autoDeleteMessageCount,
                                       boolean autoCreateAddress)
                                throws java.lang.Exception

      Deprecated.
      Create a queue.
      If `address` is `null` it will be defaulted to `name`.
      This method throws a `ActiveMQQueueExistsException`) exception if the queue already exits.
      Parameters:
        `address` - address to bind the queue to
        `routingType` - the routing type used for this address, `MULTICAST` or `ANYCAST`
        `name` - name of the queue
        `filterStr` - filter of the queue
        `durable` - is the queue durable?
        `maxConsumers` - the maximum number of consumers allowed on this queue at any one time
        `purgeOnNoConsumers` - delete this queue when the last consumer disconnects
        `exclusive` - if the queue should route exclusively to one consumer
        `lastValue` - use last-value semantics
        `consumersBeforeDispatch` - number of consumers needed before dispatch can start
        `delayBeforeDispatch` - delay to wait before dispatching if number of consumers before dispatch is not met
        `autoCreateAddress` - create an address with default values should a matching address not be found
      Returns:
        a textual summary of the queue
      Throws:
        `java.lang.Exception`

    - #### createQueue

          @Deprecated
          java.lang.String createQueue​(java.lang.String address,
                                       java.lang.String routingType,
                                       java.lang.String name,
                                       java.lang.String filterStr,
                                       boolean durable,
                                       int maxConsumers,
                                       boolean purgeOnNoConsumers,
                                       boolean exclusive,
                                       boolean groupRebalance,
                                       int groupBuckets,
                                       java.lang.String groupFirstKey,
                                       boolean lastValue,
                                       java.lang.String lastValueKey,
                                       boolean nonDestructive,
                                       int consumersBeforeDispatch,
                                       long delayBeforeDispatch,
                                       boolean autoDelete,
                                       long autoDeleteDelay,
                                       long autoDeleteMessageCount,
                                       boolean autoCreateAddress)
                                throws java.lang.Exception

      Deprecated.
      Create a queue.
      If `address` is `null` it will be defaulted to `name`.
      This method throws a `ActiveMQQueueExistsException`) exception if the queue already exits.
      Parameters:
        `address` - address to bind the queue to
        `routingType` - the routing type used for this address, `MULTICAST` or `ANYCAST`
        `name` - name of the queue
        `filterStr` - filter of the queue
        `durable` - is the queue durable?
        `maxConsumers` - the maximum number of consumers allowed on this queue at any one time
        `purgeOnNoConsumers` - delete this queue when the last consumer disconnects
        `exclusive` - if the queue should route exclusively to one consumer
        `lastValue` - use last-value semantics
        `consumersBeforeDispatch` - number of consumers needed before dispatch can start
        `delayBeforeDispatch` - delay to wait before dispatching if number of consumers before dispatch is not met
        `autoCreateAddress` - create an address with default values should a matching address not be found
      Returns:
        a textual summary of the queue
      Throws:
        `java.lang.Exception`

    - #### createQueue

          @Deprecated
          java.lang.String createQueue​(java.lang.String address,
                                       java.lang.String routingType,
                                       java.lang.String name,
                                       java.lang.String filterStr,
                                       boolean durable,
                                       int maxConsumers,
                                       boolean purgeOnNoConsumers,
                                       boolean exclusive,
                                       boolean groupRebalance,
                                       int groupBuckets,
                                       java.lang.String groupFirstKey,
                                       boolean lastValue,
                                       java.lang.String lastValueKey,
                                       boolean nonDestructive,
                                       int consumersBeforeDispatch,
                                       long delayBeforeDispatch,
                                       boolean autoDelete,
                                       long autoDeleteDelay,
                                       long autoDeleteMessageCount,
                                       boolean autoCreateAddress,
                                       long ringSize)
                                throws java.lang.Exception

      Deprecated.
      Create a queue.
      If `address` is `null` it will be defaulted to `name`.
      This method throws a `ActiveMQQueueExistsException`) exception if the queue already exits.
      Parameters:
        `address` - address to bind the queue to
        `routingType` - the routing type used for this address, `MULTICAST` or `ANYCAST`
        `name` - name of the queue
        `filterStr` - filter of the queue
        `durable` - is the queue durable?
        `maxConsumers` - the maximum number of consumers allowed on this queue at any one time
        `purgeOnNoConsumers` - delete this queue when the last consumer disconnects
        `exclusive` - if the queue should route exclusively to one consumer
        `lastValue` - use last-value semantics
        `consumersBeforeDispatch` - number of consumers needed before dispatch can start
        `delayBeforeDispatch` - delay to wait before dispatching if number of consumers before dispatch is not met
        `autoCreateAddress` - create an address with default values should a matching address not be found
        `ringSize` - the size this queue should maintain according to ring semantics
      Returns:
        a textual summary of the queue
      Throws:
        `java.lang.Exception`

    - #### createQueue

          @Deprecated
          java.lang.String createQueue​(java.lang.String address,
                                       java.lang.String routingType,
                                       java.lang.String name,
                                       java.lang.String filterStr,
                                       boolean durable,
                                       int maxConsumers,
                                       boolean purgeOnNoConsumers,
                                       boolean autoCreateAddress)
                                throws java.lang.Exception

      Deprecated.
      Create a queue.
      If `address` is `null` it will be defaulted to `name`.
      This method throws a `ActiveMQQueueExistsException`) exception if the queue already exits.
      Parameters:
        `address` - address to bind the queue to
        `routingType` - the routing type used for this address, `MULTICAST` or `ANYCAST`
        `name` - name of the queue
        `filterStr` - filter of the queue
        `durable` - is the queue durable?
        `maxConsumers` - the maximum number of consumers allowed on this queue at any one time
        `purgeOnNoConsumers` - delete this queue when the last consumer disconnects
        `autoCreateAddress` - create an address with default values should a matching address not be found
      Returns:
        a textual summary of the queue
      Throws:
        `java.lang.Exception`

    - #### createQueue

          java.lang.String createQueue​(java.lang.String queueConfiguration)
                                throws java.lang.Exception

      Create a queue.
      This method throws a `ActiveMQQueueExistsException`) exception if the queue already exists.
      Parameters:
        `queueConfiguration` - the configuration of the queue in JSON format
      Returns:
        the configuration of the created queue in JSON format
      Throws:
        `java.lang.Exception`

    - #### createQueue

          java.lang.String createQueue​(java.lang.String queueConfiguration,
                                       boolean ignoreIfExists)
                                throws java.lang.Exception

      Create a queue.
      This method throws a `ActiveMQQueueExistsException`) exception if the queue already exists and `ignoreIfExists` is `false`.
      Parameters:
        `queueConfiguration` - the configuration of the queue in JSON format
        `ignoreIfExists` - whether or not to simply return without an exception if the queue exists
      Returns:
        the configuration of the created queue in JSON format
      Throws:
        `java.lang.Exception`

    - #### updateQueue

          java.lang.String updateQueue​(java.lang.String queueConfiguration)
                                throws java.lang.Exception

      Update a queue.
      Parameters:
        `queueConfiguration` - the configuration of the queue in JSON format
      Returns:
        the configuration of the created queue in JSON format
      Throws:
        `java.lang.Exception`

    - #### updateQueue

          @Deprecated
          java.lang.String updateQueue​(java.lang.String name,
                                       java.lang.String routingType,
                                       java.lang.Integer maxConsumers,
                                       java.lang.Boolean purgeOnNoConsumers)
                                throws java.lang.Exception

      Deprecated.
      Update a queue.
      Parameters:
        `name` - name of the queue
        `routingType` - the routing type used for this address, `MULTICAST` or `ANYCAST`
        `maxConsumers` - the maximum number of consumers allowed on this queue at any one time
        `purgeOnNoConsumers` - delete this queue when the last consumer disconnects
      Returns:
        a textual summary of the queue
      Throws:
        `java.lang.Exception`

    - #### updateQueue

          @Deprecated
          java.lang.String updateQueue​(java.lang.String name,
                                       java.lang.String routingType,
                                       java.lang.Integer maxConsumers,
                                       java.lang.Boolean purgeOnNoConsumers,
                                       java.lang.Boolean exclusive)
                                throws java.lang.Exception

      Deprecated.
      Update a queue.
      Parameters:
        `name` - name of the queue
        `routingType` - the routing type used for this address, `MULTICAST` or `ANYCAST`
        `maxConsumers` - the maximum number of consumers allowed on this queue at any one time
        `purgeOnNoConsumers` - delete this queue when the last consumer disconnects
        `exclusive` - if the queue should route exclusively to one consumer
      Returns:
        a textual summary of the queue
      Throws:
        `java.lang.Exception`

    - #### updateQueue

          @Deprecated
          java.lang.String updateQueue​(java.lang.String name,
                                       java.lang.String routingType,
                                       java.lang.Integer maxConsumers,
                                       java.lang.Boolean purgeOnNoConsumers,
                                       java.lang.Boolean exclusive,
                                       java.lang.String user)
                                throws java.lang.Exception

      Deprecated.
      Update a queue
      Parameters:
        `name` - name of the queue
        `routingType` - the routing type used for this address, `MULTICAST` or `ANYCAST`
        `maxConsumers` - the maximum number of consumers allowed on this queue at any one time
        `purgeOnNoConsumers` - delete this queue when the last consumer disconnects
        `exclusive` - if the queue should route exclusively to one consumer
        `user` - the user associated with this queue
      Returns:
      Throws:
        `java.lang.Exception`

    - #### updateQueue

          @Deprecated
          java.lang.String updateQueue​(java.lang.String name,
                                       java.lang.String routingType,
                                       java.lang.String filter,
                                       java.lang.Integer maxConsumers,
                                       java.lang.Boolean purgeOnNoConsumers,
                                       java.lang.Boolean exclusive,
                                       java.lang.Boolean groupRebalance,
                                       java.lang.Integer groupBuckets,
                                       java.lang.Boolean nonDestructive,
                                       java.lang.Integer consumersBeforeDispatch,
                                       java.lang.Long delayBeforeDispatch,
                                       java.lang.String user)
                                throws java.lang.Exception

      Deprecated.
      Update a queue
      Parameters:
        `name` - name of the queue
        `routingType` - the routing type used for this address, `MULTICAST` or `ANYCAST`
        `filter` - the filter to use on the queue
        `maxConsumers` - the maximum number of consumers allowed on this queue at any one time
        `purgeOnNoConsumers` - delete this queue when the last consumer disconnects
        `exclusive` - if the queue should route exclusively to one consumer
        `groupRebalance` - if the queue should rebalance groups when a consumer is added
        `groupBuckets` - number of buckets that should be used for message groups, -1 (default) is unlimited, and groups by raw key instead
        `nonDestructive` - If the queue is non-destructive
        `consumersBeforeDispatch` - number of consumers needed before dispatch can start
        `delayBeforeDispatch` - delay to wait before dispatching if number of consumers before dispatch is not met
        `user` - the user associated with this queue
      Returns:
      Throws:
        `java.lang.Exception`

    - #### updateQueue

          @Deprecated
          java.lang.String updateQueue​(java.lang.String name,
                                       java.lang.String routingType,
                                       java.lang.String filter,
                                       java.lang.Integer maxConsumers,
                                       java.lang.Boolean purgeOnNoConsumers,
                                       java.lang.Boolean exclusive,
                                       java.lang.Boolean groupRebalance,
                                       java.lang.Integer groupBuckets,
                                       java.lang.String groupFirstKey,
                                       java.lang.Boolean nonDestructive,
                                       java.lang.Integer consumersBeforeDispatch,
                                       java.lang.Long delayBeforeDispatch,
                                       java.lang.String user)
                                throws java.lang.Exception

      Deprecated.
      Update a queue
      Parameters:
        `name` - name of the queue
        `routingType` - the routing type used for this address, `MULTICAST` or `ANYCAST`
        `filter` - the filter to use on the queue
        `maxConsumers` - the maximum number of consumers allowed on this queue at any one time
        `purgeOnNoConsumers` - delete this queue when the last consumer disconnects
        `exclusive` - if the queue should route exclusively to one consumer
        `groupRebalance` - if the queue should rebalance groups when a consumer is added
        `groupBuckets` - number of buckets that should be used for message groups, -1 (default) is unlimited, and groups by raw key instead
        `groupFirstKey` - key used to mark a message is first in a group for a consumer
        `nonDestructive` - If the queue is non-destructive
        `consumersBeforeDispatch` - number of consumers needed before dispatch can start
        `delayBeforeDispatch` - delay to wait before dispatching if number of consumers before dispatch is not met
        `user` - the user associated with this queue
      Returns:
      Throws:
        `java.lang.Exception`

    - #### updateQueue

          @Deprecated
          java.lang.String updateQueue​(java.lang.String name,
                                       java.lang.String routingType,
                                       java.lang.String filter,
                                       java.lang.Integer maxConsumers,
                                       java.lang.Boolean purgeOnNoConsumers,
                                       java.lang.Boolean exclusive,
                                       java.lang.Boolean groupRebalance,
                                       java.lang.Integer groupBuckets,
                                       java.lang.String groupFirstKey,
                                       java.lang.Boolean nonDestructive,
                                       java.lang.Integer consumersBeforeDispatch,
                                       java.lang.Long delayBeforeDispatch,
                                       java.lang.String user,
                                       java.lang.Long ringSize)
                                throws java.lang.Exception

      Deprecated.
      Update a queue
      Parameters:
        `name` - name of the queue
        `routingType` - the routing type used for this address, `MULTICAST` or `ANYCAST`
        `filter` - the filter to use on the queue
        `maxConsumers` - the maximum number of consumers allowed on this queue at any one time
        `purgeOnNoConsumers` - delete this queue when the last consumer disconnects
        `exclusive` - if the queue should route exclusively to one consumer
        `groupRebalance` - if the queue should rebalance groups when a consumer is added
        `groupBuckets` - number of buckets that should be used for message groups, -1 (default) is unlimited, and groups by raw key instead
        `groupFirstKey` - key used to mark a message is first in a group for a consumer
        `nonDestructive` - If the queue is non-destructive
        `consumersBeforeDispatch` - number of consumers needed before dispatch can start
        `delayBeforeDispatch` - delay to wait before dispatching if number of consumers before dispatch is not met
        `user` - the user associated with this queue
        `ringSize` - the size this queue should maintain according to ring semantics
      Returns:
      Throws:
        `java.lang.Exception`

    - #### deployQueue

          @Deprecated
          void deployQueue​(java.lang.String address,
                           java.lang.String name,
                           java.lang.String filter)
                    throws java.lang.Exception

      Deprecated.
      Deploy a durable queue.
      If `address` is `null` it will be defaulted to `name`.
      This method will do nothing if the queue with the given name already exists on the server.
      Parameters:
        `address` - address to bind the queue to
        `name` - name of the queue
        `filter` - of the queue
      Throws:
        `java.lang.Exception`

    - #### deployQueue

          @Deprecated
          void deployQueue​(java.lang.String address,
                           java.lang.String name,
                           java.lang.String filter,
                           boolean durable)
                    throws java.lang.Exception

      Deprecated.
      Deploy a queue.
      If `address` is `null` it will be defaulted to `name`.
      This method will do nothing if the queue with the given name already exists on the server.
      Parameters:
        `address` - address to bind the queue to
        `name` - name of the queue
        `filter` - of the queue
        `durable` - whether the queue is durable
      Throws:
        `java.lang.Exception`

    - #### destroyQueue

          void destroyQueue​(java.lang.String name)
                     throws java.lang.Exception

      Destroys the queue corresponding to the specified name.
      Throws:
        `java.lang.Exception`

    - #### destroyQueue

          void destroyQueue​(java.lang.String name,
                            boolean removeConsumers)
                     throws java.lang.Exception

      Destroys the queue corresponding to the specified name.
      Throws:
        `java.lang.Exception`

    - #### destroyQueue

          void destroyQueue​(java.lang.String name,
                            boolean removeConsumers,
                            boolean autoDeleteAddress)
                     throws java.lang.Exception

      Destroys the queue corresponding to the specified name and delete it's address if there are no other queues
      Throws:
        `java.lang.Exception`

    - #### enableMessageCounters

          void enableMessageCounters()
                              throws java.lang.Exception

      Enables message counters for this server.
      Throws:
        `java.lang.Exception`

    - #### disableMessageCounters

          void disableMessageCounters()
                               throws java.lang.Exception

      Disables message counters for this server.
      Throws:
        `java.lang.Exception`

    - #### resetAllMessageCounters

          void resetAllMessageCounters()
                                throws java.lang.Exception

      Reset all message counters.
      Throws:
        `java.lang.Exception`

    - #### resetAllMessageCounterHistories

          void resetAllMessageCounterHistories()
                                        throws java.lang.Exception

      Reset histories for all message counters.
      Throws:
        `java.lang.Exception`

    - #### listPreparedTransactions

          java.lang.String[] listPreparedTransactions()
                                               throws java.lang.Exception

      List all the prepared transaction, sorted by date, oldest first.
      The Strings are Base-64 representation of the transaction XID and can be used to heuristically commit or rollback the transactions.
      Throws:
        `java.lang.Exception`
      See Also:
        `commitPreparedTransaction(String)`, `rollbackPreparedTransaction(String)`

    - #### listPreparedTransactionDetailsAsJSON

          java.lang.String listPreparedTransactionDetailsAsJSON()
                                                         throws java.lang.Exception

      List all the prepared transaction, sorted by date, oldest first, with details, in text format.
      Throws:
        `java.lang.Exception`

    - #### listPreparedTransactionDetailsAsHTML

          @Deprecated
          java.lang.String listPreparedTransactionDetailsAsHTML()
                                                         throws java.lang.Exception

      Deprecated.
      List all the prepared transaction, sorted by date, oldest first, with details, in HTML format
      Throws:
        `java.lang.Exception`

    - #### listHeuristicCommittedTransactions

          java.lang.String[] listHeuristicCommittedTransactions()
                                                         throws java.lang.Exception

      List transactions which have been heuristically committed.
      Throws:
        `java.lang.Exception`

    - #### listHeuristicRolledBackTransactions

          java.lang.String[] listHeuristicRolledBackTransactions()
                                                          throws java.lang.Exception

      List transactions which have been heuristically rolled back.
      Throws:
        `java.lang.Exception`

    - #### commitPreparedTransaction

          boolean commitPreparedTransaction​(java.lang.String transactionAsBase64)
                                     throws java.lang.Exception

      Heuristically commits a prepared transaction.
      Parameters:
        `transactionAsBase64` - base 64 representation of a prepare transaction
      Returns:
        `true` if the transaction was successfully committed, `false` else
      Throws:
        `java.lang.Exception`
      See Also:
        `listPreparedTransactions()`

    - #### rollbackPreparedTransaction

          boolean rollbackPreparedTransaction​(java.lang.String transactionAsBase64)
                                       throws java.lang.Exception

      Heuristically rolls back a prepared transaction.
      Parameters:
        `transactionAsBase64` - base 64 representation of a prepare transaction
      Returns:
        `true` if the transaction was successfully rolled back, `false` else
      Throws:
        `java.lang.Exception`
      See Also:
        `listPreparedTransactions()`

    - #### listRemoteAddresses

          java.lang.String[] listRemoteAddresses()
                                          throws java.lang.Exception

      Lists the addresses of all the clients connected to this address.
      Throws:
        `java.lang.Exception`

    - #### listRemoteAddresses

          java.lang.String[] listRemoteAddresses​(java.lang.String ipAddress)
                                          throws java.lang.Exception

      Lists the addresses of the clients connected to this address which matches the specified IP address.
      Throws:
        `java.lang.Exception`

    - #### closeConnectionsForAddress

          boolean closeConnectionsForAddress​(java.lang.String ipAddress)
                                      throws java.lang.Exception

      Closes all the connections of clients connected to this server which matches the specified IP address.
      Throws:
        `java.lang.Exception`

    - #### closeConsumerConnectionsForAddress

          boolean closeConsumerConnectionsForAddress​(java.lang.String address)
                                              throws java.lang.Exception

      Closes all the connections of clients connected to this server which matches the specified IP address.
      Throws:
        `java.lang.Exception`

    - #### closeConnectionsForUser

          boolean closeConnectionsForUser​(java.lang.String address)
                                   throws java.lang.Exception

      Closes all the connections of sessions with a matching user name.
      Throws:
        `java.lang.Exception`

    - #### closeConnectionWithID

          boolean closeConnectionWithID​(java.lang.String ID)
                                 throws java.lang.Exception

      Closes the connection with the given id.
      Throws:
        `java.lang.Exception`

    - #### closeSessionWithID

          boolean closeSessionWithID​(java.lang.String connectionID,
                                     java.lang.String ID)
                              throws java.lang.Exception

      Closes the session with the given id.
      Throws:
        `java.lang.Exception`

    - #### closeConsumerWithID

          boolean closeConsumerWithID​(java.lang.String sessionID,
                                      java.lang.String ID)
                               throws java.lang.Exception

      Closes the consumer with the given id.
      Throws:
        `java.lang.Exception`

    - #### listConnectionIDs

          java.lang.String[] listConnectionIDs()
                                        throws java.lang.Exception

      Lists all the IDs of the connections connected to this server.
      Throws:
        `java.lang.Exception`

    - #### listProducersInfoAsJSON

          java.lang.String listProducersInfoAsJSON()
                                            throws java.lang.Exception

      Throws:
        `java.lang.Exception`

    - #### listConnectionsAsJSON

          java.lang.String listConnectionsAsJSON()
                                          throws java.lang.Exception

      Lists all the connections connected to this server. The returned String is a JSON string containing details about each connection, e.g.:

           [
             {
               "creationTime": 1469240429671,
               "sessionCount": 1,
               "implementation": "RemotingConnectionImpl",
               "connectionID": "1648309901",
               "clientAddress": "\/127.0.0.1:57649"
             }
           ]

      Throws:
        `java.lang.Exception`

    - #### listConsumersAsJSON

          java.lang.String listConsumersAsJSON​(java.lang.String connectionID)
                                        throws java.lang.Exception

      Lists all the consumers which belongs to the connection specified by the connectionID. The returned String is a JSON string containing details about each consumer, e.g.:

           [
             {
               "filter": "color = 'RED'",
               "queueName": "2ea5b050-28bf-4ee2-9b24-b73f5983192a",
               "creationTime": 1469239602459,
               "deliveringCount": 0,
               "consumerID": 1,
               "browseOnly": true,
               "connectionID": "1963ece3-507a-11e6-94ff-e8b1fc439540",
               "sessionID": "19676f55-507a-11e6-94ff-e8b1fc439540"
             }
           ]

      Throws:
        `java.lang.Exception`

    - #### listAllConsumersAsJSON

          java.lang.String listAllConsumersAsJSON()
                                           throws java.lang.Exception

      Lists all the consumers connected to this server. The returned String is a JSON string containing details about each consumer, e.g.:

           [
             {
               "queueName": "fa87c64c-0a38-4697-8421-72e34d17429d",
               "creationTime": 1469235956168,
               "deliveringCount": 0,
               "consumerID": 0,
               "browseOnly": false,
               "connectionID": "9c0d42e7-5071-11e6-9e29-e8b1fc439540",
               "sessionID": "9c0d9109-5071-11e6-9e29-e8b1fc439540"
             }
           ]

      Throws:
        `java.lang.Exception`

    - #### listSessionsAsJSON

          java.lang.String listSessionsAsJSON​(java.lang.String connectionID)
                                       throws java.lang.Exception

      Lists details about all the sessions for the specified connection ID. The returned String is a JSON string containing details about each session associated with the specified ID, e.g.:

           [
             {
               "principal": "myUser",
               "creationTime": 1469240773157,
               "consumerCount": 0,
               "sessionID": "d33d10db-507c-11e6-9e47-e8b1fc439540"
             }
           ]

      Throws:
        `java.lang.Exception`

    - #### listAllSessionsAsJSON

          java.lang.String listAllSessionsAsJSON()
                                          throws java.lang.Exception

      Lists details about all sessions. The returned String is a JSON string containing details about each and every session, e.g.:

           [
             {
               "sessionID":"e71d61d7-2176-11e8-9057-a0afbd82eaba",
               "creationTime":1520365520212,
               "consumerCount":1,
               "principal":"myUser"
             },
             {
               "sessionID":"e718a6e6-2176-11e8-9057-a0afbd82eaba",
               "creationTime":1520365520191,
               "consumerCount":0,
               "principal":"guest"
             }
           ]

      Throws:
        `java.lang.Exception`

    - #### listSessions

          java.lang.String[] listSessions​(java.lang.String connectionID)
                                   throws java.lang.Exception

      Lists all the sessions IDs for the specified connection ID.
      Throws:
        `java.lang.Exception`

    - #### addSecuritySettings

          void addSecuritySettings​(java.lang.String addressMatch,
                                   java.lang.String sendRoles,
                                   java.lang.String consumeRoles,
                                   java.lang.String createDurableQueueRoles,
                                   java.lang.String deleteDurableQueueRoles,
                                   java.lang.String createNonDurableQueueRoles,
                                   java.lang.String deleteNonDurableQueueRoles,
                                   java.lang.String manageRoles)
                            throws java.lang.Exception

      Throws:
        `java.lang.Exception`

    - #### addSecuritySettings

          void addSecuritySettings​(java.lang.String addressMatch,
                                   java.lang.String sendRoles,
                                   java.lang.String consumeRoles,
                                   java.lang.String createDurableQueueRoles,
                                   java.lang.String deleteDurableQueueRoles,
                                   java.lang.String createNonDurableQueueRoles,
                                   java.lang.String deleteNonDurableQueueRoles,
                                   java.lang.String manageRoles,
                                   java.lang.String browseRoles)
                            throws java.lang.Exception

      Throws:
        `java.lang.Exception`

    - #### addSecuritySettings

          void addSecuritySettings​(java.lang.String addressMatch,
                                   java.lang.String sendRoles,
                                   java.lang.String consumeRoles,
                                   java.lang.String createDurableQueueRoles,
                                   java.lang.String deleteDurableQueueRoles,
                                   java.lang.String createNonDurableQueueRoles,
                                   java.lang.String deleteNonDurableQueueRoles,
                                   java.lang.String manageRoles,
                                   java.lang.String browseRoles,
                                   java.lang.String createAddressRoles,
                                   java.lang.String deleteAddressRoles)
                            throws java.lang.Exception

      Throws:
        `java.lang.Exception`

    - #### removeSecuritySettings

          void removeSecuritySettings​(java.lang.String addressMatch)
                               throws java.lang.Exception

      Throws:
        `java.lang.Exception`

    - #### getRoles

          java.lang.Object[] getRoles​(java.lang.String addressMatch)
                               throws java.lang.Exception

      Throws:
        `java.lang.Exception`

    - #### getRolesAsJSON

          java.lang.String getRolesAsJSON​(java.lang.String addressMatch)
                                   throws java.lang.Exception

      Throws:
        `java.lang.Exception`

    - #### addAddressSettings

          void addAddressSettings​(java.lang.String addressMatch,
                                  java.lang.String DLA,
                                  java.lang.String expiryAddress,
                                  long expiryDelay,
                                  boolean lastValueQueue,
                                  int deliveryAttempts,
                                  long maxSizeBytes,
                                  int pageSizeBytes,
                                  int pageMaxCacheSize,
                                  long redeliveryDelay,
                                  double redeliveryMultiplier,
                                  long maxRedeliveryDelay,
                                  long redistributionDelay,
                                  boolean sendToDLAOnNoRoute,
                                  java.lang.String addressFullMessagePolicy,
                                  long slowConsumerThreshold,
                                  long slowConsumerCheckPeriod,
                                  java.lang.String slowConsumerPolicy,
                                  boolean autoCreateJmsQueues,
                                  boolean autoDeleteJmsQueues,
                                  boolean autoCreateJmsTopics,
                                  boolean autoDeleteJmsTopics)
                           throws java.lang.Exception

      adds a new address setting for a specific address
      Throws:
        `java.lang.Exception`

    - #### addAddressSettings

          void addAddressSettings​(java.lang.String addressMatch,
                                  java.lang.String DLA,
                                  java.lang.String expiryAddress,
                                  long expiryDelay,
                                  boolean lastValueQueue,
                                  int deliveryAttempts,
                                  long maxSizeBytes,
                                  int pageSizeBytes,
                                  int pageMaxCacheSize,
                                  long redeliveryDelay,
                                  double redeliveryMultiplier,
                                  long maxRedeliveryDelay,
                                  long redistributionDelay,
                                  boolean sendToDLAOnNoRoute,
                                  java.lang.String addressFullMessagePolicy,
                                  long slowConsumerThreshold,
                                  long slowConsumerCheckPeriod,
                                  java.lang.String slowConsumerPolicy,
                                  boolean autoCreateJmsQueues,
                                  boolean autoDeleteJmsQueues,
                                  boolean autoCreateJmsTopics,
                                  boolean autoDeleteJmsTopics,
                                  boolean autoCreateQueues,
                                  boolean autoDeleteQueues,
                                  boolean autoCreateAddresses,
                                  boolean autoDeleteAddresses)
                           throws java.lang.Exception

      adds a new address setting for a specific address
      Throws:
        `java.lang.Exception`

    - #### addAddressSettings

          void addAddressSettings​(java.lang.String addressMatch,
                                  java.lang.String DLA,
                                  java.lang.String expiryAddress,
                                  long expiryDelay,
                                  boolean lastValueQueue,
                                  int deliveryAttempts,
                                  long maxSizeBytes,
                                  int pageSizeBytes,
                                  int pageMaxCacheSize,
                                  long redeliveryDelay,
                                  double redeliveryMultiplier,
                                  long maxRedeliveryDelay,
                                  long redistributionDelay,
                                  boolean sendToDLAOnNoRoute,
                                  java.lang.String addressFullMessagePolicy,
                                  long slowConsumerThreshold,
                                  long slowConsumerCheckPeriod,
                                  java.lang.String slowConsumerPolicy,
                                  boolean autoCreateJmsQueues,
                                  boolean autoDeleteJmsQueues,
                                  boolean autoCreateJmsTopics,
                                  boolean autoDeleteJmsTopics,
                                  boolean autoCreateQueues,
                                  boolean autoDeleteQueues,
                                  boolean autoCreateAddresses,
                                  boolean autoDeleteAddresses,
                                  java.lang.String configDeleteQueues,
                                  java.lang.String configDeleteAddresses,
                                  long maxSizeBytesRejectThreshold,
                                  java.lang.String defaultLastValueKey,
                                  boolean defaultNonDestructive,
                                  boolean defaultExclusiveQueue,
                                  boolean defaultGroupRebalance,
                                  int defaultGroupBuckets,
                                  java.lang.String defaultGroupFirstKey,
                                  int defaultMaxConsumers,
                                  boolean defaultPurgeOnNoConsumers,
                                  int defaultConsumersBeforeDispatch,
                                  long defaultDelayBeforeDispatch,
                                  java.lang.String defaultQueueRoutingType,
                                  java.lang.String defaultAddressRoutingType,
                                  int defaultConsumerWindowSize,
                                  long defaultRingSize,
                                  boolean autoDeleteCreatedQueues,
                                  long autoDeleteQueuesDelay,
                                  long autoDeleteQueuesMessageCount,
                                  long autoDeleteAddressesDelay,
                                  double redeliveryCollisionAvoidanceFactor,
                                  long retroactiveMessageCount)
                           throws java.lang.Exception

      adds a new address setting for a specific address
      Throws:
        `java.lang.Exception`

    - #### addAddressSettings

          void addAddressSettings​(java.lang.String addressMatch,
                                  java.lang.String DLA,
                                  java.lang.String expiryAddress,
                                  long expiryDelay,
                                  boolean lastValueQueue,
                                  int deliveryAttempts,
                                  long maxSizeBytes,
                                  int pageSizeBytes,
                                  int pageMaxCacheSize,
                                  long redeliveryDelay,
                                  double redeliveryMultiplier,
                                  long maxRedeliveryDelay,
                                  long redistributionDelay,
                                  boolean sendToDLAOnNoRoute,
                                  java.lang.String addressFullMessagePolicy,
                                  long slowConsumerThreshold,
                                  long slowConsumerCheckPeriod,
                                  java.lang.String slowConsumerPolicy,
                                  boolean autoCreateJmsQueues,
                                  boolean autoDeleteJmsQueues,
                                  boolean autoCreateJmsTopics,
                                  boolean autoDeleteJmsTopics,
                                  boolean autoCreateQueues,
                                  boolean autoDeleteQueues,
                                  boolean autoCreateAddresses,
                                  boolean autoDeleteAddresses,
                                  java.lang.String configDeleteQueues,
                                  java.lang.String configDeleteAddresses,
                                  long maxSizeBytesRejectThreshold,
                                  java.lang.String defaultLastValueKey,
                                  boolean defaultNonDestructive,
                                  boolean defaultExclusiveQueue,
                                  boolean defaultGroupRebalance,
                                  int defaultGroupBuckets,
                                  java.lang.String defaultGroupFirstKey,
                                  int defaultMaxConsumers,
                                  boolean defaultPurgeOnNoConsumers,
                                  int defaultConsumersBeforeDispatch,
                                  long defaultDelayBeforeDispatch,
                                  java.lang.String defaultQueueRoutingType,
                                  java.lang.String defaultAddressRoutingType,
                                  int defaultConsumerWindowSize,
                                  long defaultRingSize,
                                  boolean autoDeleteCreatedQueues,
                                  long autoDeleteQueuesDelay,
                                  long autoDeleteQueuesMessageCount,
                                  long autoDeleteAddressesDelay,
                                  double redeliveryCollisionAvoidanceFactor,
                                  long retroactiveMessageCount,
                                  boolean autoCreateDeadLetterResources,
                                  java.lang.String deadLetterQueuePrefix,
                                  java.lang.String deadLetterQueueSuffix,
                                  boolean autoCreateExpiryResources,
                                  java.lang.String expiryQueuePrefix,
                                  java.lang.String expiryQueueSuffix)
                           throws java.lang.Exception

      adds a new address setting for a specific address
      Throws:
        `java.lang.Exception`

    - #### addAddressSettings

          void addAddressSettings​(java.lang.String addressMatch,
                                  java.lang.String DLA,
                                  java.lang.String expiryAddress,
                                  long expiryDelay,
                                  boolean lastValueQueue,
                                  int maxDeliveryAttempts,
                                  long maxSizeBytes,
                                  int pageSizeBytes,
                                  int pageCacheMaxSize,
                                  long redeliveryDelay,
                                  double redeliveryMultiplier,
                                  long maxRedeliveryDelay,
                                  long redistributionDelay,
                                  boolean sendToDLAOnNoRoute,
                                  java.lang.String addressFullMessagePolicy,
                                  long slowConsumerThreshold,
                                  long slowConsumerCheckPeriod,
                                  java.lang.String slowConsumerPolicy,
                                  boolean autoCreateJmsQueues,
                                  boolean autoDeleteJmsQueues,
                                  boolean autoCreateJmsTopics,
                                  boolean autoDeleteJmsTopics,
                                  boolean autoCreateQueues,
                                  boolean autoDeleteQueues,
                                  boolean autoCreateAddresses,
                                  boolean autoDeleteAddresses,
                                  java.lang.String configDeleteQueues,
                                  java.lang.String configDeleteAddresses,
                                  long maxSizeBytesRejectThreshold,
                                  java.lang.String defaultLastValueKey,
                                  boolean defaultNonDestructive,
                                  boolean defaultExclusiveQueue,
                                  boolean defaultGroupRebalance,
                                  int defaultGroupBuckets,
                                  java.lang.String defaultGroupFirstKey,
                                  int defaultMaxConsumers,
                                  boolean defaultPurgeOnNoConsumers,
                                  int defaultConsumersBeforeDispatch,
                                  long defaultDelayBeforeDispatch,
                                  java.lang.String defaultQueueRoutingType,
                                  java.lang.String defaultAddressRoutingType,
                                  int defaultConsumerWindowSize,
                                  long defaultRingSize,
                                  boolean autoDeleteCreatedQueues,
                                  long autoDeleteQueuesDelay,
                                  long autoDeleteQueuesMessageCount,
                                  long autoDeleteAddressesDelay,
                                  double redeliveryCollisionAvoidanceFactor,
                                  long retroactiveMessageCount,
                                  boolean autoCreateDeadLetterResources,
                                  java.lang.String deadLetterQueuePrefix,
                                  java.lang.String deadLetterQueueSuffix,
                                  boolean autoCreateExpiryResources,
                                  java.lang.String expiryQueuePrefix,
                                  java.lang.String expiryQueueSuffix,
                                  long minExpiryDelay,
                                  long maxExpiryDelay,
                                  boolean enableMetrics)
                           throws java.lang.Exception

      adds a new address setting for a specific address
      Throws:
        `java.lang.Exception`

    - #### removeAddressSettings

          void removeAddressSettings​(java.lang.String addressMatch)
                              throws java.lang.Exception

      Throws:
        `java.lang.Exception`

    - #### getAddressSettingsAsJSON

          java.lang.String getAddressSettingsAsJSON​(java.lang.String addressMatch)
                                             throws java.lang.Exception

      returns the address settings as a JSON string
      Throws:
        `java.lang.Exception`

    - #### getDivertNames

          java.lang.String[] getDivertNames()

    - #### listDivertNames

          default java.lang.String[] listDivertNames()

      Jon plugin doesn't recognize an Operation whose name is in form getXXXX(), so add this one.

    - #### createDivert

          void createDivert​(java.lang.String name,
                            java.lang.String routingName,
                            java.lang.String address,
                            java.lang.String forwardingAddress,
                            boolean exclusive,
                            java.lang.String filterString,
                            java.lang.String transformerClassName)
                     throws java.lang.Exception

      Throws:
        `java.lang.Exception`

    - #### createDivert

          void createDivert​(java.lang.String name,
                            java.lang.String routingName,
                            java.lang.String address,
                            java.lang.String forwardingAddress,
                            boolean exclusive,
                            java.lang.String filterString,
                            java.lang.String transformerClassName,
                            java.lang.String routingType)
                     throws java.lang.Exception

      Throws:
        `java.lang.Exception`

    - #### createDivert

          void createDivert​(java.lang.String name,
                            java.lang.String routingName,
                            java.lang.String address,
                            java.lang.String forwardingAddress,
                            boolean exclusive,
                            java.lang.String filterString,
                            java.lang.String transformerClassName,
                            java.util.Map<java.lang.String,​java.lang.String> transformerProperties,
                            java.lang.String routingType)
                     throws java.lang.Exception

      Throws:
        `java.lang.Exception`

    - #### createDivert

          void createDivert​(java.lang.String name,
                            java.lang.String routingName,
                            java.lang.String address,
                            java.lang.String forwardingAddress,
                            boolean exclusive,
                            java.lang.String filterString,
                            java.lang.String transformerClassName,
                            java.lang.String transformerPropertiesAsJSON,
                            java.lang.String routingType)
                     throws java.lang.Exception

      Throws:
        `java.lang.Exception`

    - #### updateDivert

          void updateDivert​(java.lang.String name,
                            java.lang.String forwardingAddress,
                            java.lang.String filterString,
                            java.lang.String transformerClassName,
                            java.util.Map<java.lang.String,​java.lang.String> transformerProperties,
                            java.lang.String routingType)
                     throws java.lang.Exception

      update a divert
      Throws:
        `java.lang.Exception`

    - #### destroyDivert

          void destroyDivert​(java.lang.String name)
                      throws java.lang.Exception

      Throws:
        `java.lang.Exception`

    - #### getBridgeNames

          java.lang.String[] getBridgeNames()

    - #### createBridge

          @Deprecated
          void createBridge​(java.lang.String name,
                            java.lang.String queueName,
                            java.lang.String forwardingAddress,
                            java.lang.String filterString,
                            java.lang.String transformerClassName,
                            long retryInterval,
                            double retryIntervalMultiplier,
                            int initialConnectAttempts,
                            int reconnectAttempts,
                            boolean useDuplicateDetection,
                            int confirmationWindowSize,
                            int producerWindowSize,
                            long clientFailureCheckPeriod,
                            java.lang.String connectorNames,
                            boolean useDiscoveryGroup,
                            boolean ha,
                            java.lang.String user,
                            java.lang.String password)
                     throws java.lang.Exception

      Deprecated.
      Deprecated in favour of `createBridge(String)`
      Throws:
        `java.lang.Exception`

    - #### createBridge

          @Deprecated
          void createBridge​(java.lang.String name,
                            java.lang.String queueName,
                            java.lang.String forwardingAddress,
                            java.lang.String filterString,
                            java.lang.String transformerClassName,
                            java.util.Map<java.lang.String,​java.lang.String> transformerProperties,
                            long retryInterval,
                            double retryIntervalMultiplier,
                            int initialConnectAttempts,
                            int reconnectAttempts,
                            boolean useDuplicateDetection,
                            int confirmationWindowSize,
                            int producerWindowSize,
                            long clientFailureCheckPeriod,
                            java.lang.String connectorNames,
                            boolean useDiscoveryGroup,
                            boolean ha,
                            java.lang.String user,
                            java.lang.String password)
                     throws java.lang.Exception

      Deprecated.
      Deprecated in favour of `createBridge(String)`
      Throws:
        `java.lang.Exception`

    - #### createBridge

          @Deprecated
          void createBridge​(java.lang.String name,
                            java.lang.String queueName,
                            java.lang.String forwardingAddress,
                            java.lang.String filterString,
                            java.lang.String transformerClassName,
                            java.lang.String transformerPropertiesAsJSON,
                            long retryInterval,
                            double retryIntervalMultiplier,
                            int initialConnectAttempts,
                            int reconnectAttempts,
                            boolean useDuplicateDetection,
                            int confirmationWindowSize,
                            int producerWindowSize,
                            long clientFailureCheckPeriod,
                            java.lang.String connectorNames,
                            boolean useDiscoveryGroup,
                            boolean ha,
                            java.lang.String user,
                            java.lang.String password)
                     throws java.lang.Exception

      Deprecated.
      Deprecated in favour of `createBridge(String)`
      Throws:
        `java.lang.Exception`

    - #### createBridge

          @Deprecated
          void createBridge​(java.lang.String name,
                            java.lang.String queueName,
                            java.lang.String forwardingAddress,
                            java.lang.String filterString,
                            java.lang.String transformerClassName,
                            long retryInterval,
                            double retryIntervalMultiplier,
                            int initialConnectAttempts,
                            int reconnectAttempts,
                            boolean useDuplicateDetection,
                            int confirmationWindowSize,
                            long clientFailureCheckPeriod,
                            java.lang.String connectorNames,
                            boolean useDiscoveryGroup,
                            boolean ha,
                            java.lang.String user,
                            java.lang.String password)
                     throws java.lang.Exception

      Deprecated.
      Deprecated in favour of `createBridge(String)`
      Throws:
        `java.lang.Exception`

    - #### createBridge

          void createBridge​(java.lang.String bridgeConfiguration)
                     throws java.lang.Exception

      Create a bridge.
      Parameters:
        `bridgeConfiguration` - the configuration of the queue in JSON format
      Throws:
        `java.lang.Exception`

    - #### destroyBridge

          void destroyBridge​(java.lang.String name)
                      throws java.lang.Exception

      Throws:
        `java.lang.Exception`

    - #### listBrokerConnections

          java.lang.String listBrokerConnections()

    - #### startBrokerConnection

          void startBrokerConnection​(java.lang.String name)
                              throws java.lang.Exception

      Throws:
        `java.lang.Exception`

    - #### stopBrokerConnection

          void stopBrokerConnection​(java.lang.String name)
                             throws java.lang.Exception

      Throws:
        `java.lang.Exception`

    - #### createConnectorService

          void createConnectorService​(java.lang.String name,
                                      java.lang.String factoryClass,
                                      java.util.Map<java.lang.String,​java.lang.Object> parameters)
                               throws java.lang.Exception

      Throws:
        `java.lang.Exception`

    - #### destroyConnectorService

          void destroyConnectorService​(java.lang.String name)
                                throws java.lang.Exception

      Throws:
        `java.lang.Exception`

    - #### getConnectorServices

          java.lang.String[] getConnectorServices()

    - #### forceFailover

          void forceFailover()
                      throws java.lang.Exception

      Throws:
        `java.lang.Exception`

    - #### scaleDown

          void scaleDown​(java.lang.String connector)
                  throws java.lang.Exception

      Throws:
        `java.lang.Exception`

    - #### listNetworkTopology

          java.lang.String listNetworkTopology()
                                        throws java.lang.Exception

      Throws:
        `java.lang.Exception`

    - #### getAddressInfo

          java.lang.String getAddressInfo​(java.lang.String address)
                                   throws org.apache.activemq.artemis.api.core.ActiveMQAddressDoesNotExistException

      Throws:
        `org.apache.activemq.artemis.api.core.ActiveMQAddressDoesNotExistException`

    - #### listBindingsForAddress

          java.lang.String listBindingsForAddress​(java.lang.String address)
                                           throws java.lang.Exception

      Throws:
        `java.lang.Exception`

    - #### listAddresses

          java.lang.String listAddresses​(java.lang.String separator)
                                  throws java.lang.Exception

      Throws:
        `java.lang.Exception`

    - #### listConnections

          java.lang.String listConnections​(java.lang.String options,
                                           int page,
                                           int pageSize)
                                    throws java.lang.Exception

      Throws:
        `java.lang.Exception`

    - #### listSessions

          java.lang.String listSessions​(java.lang.String options,
                                        int page,
                                        int pageSize)
                                 throws java.lang.Exception

      Throws:
        `java.lang.Exception`

    - #### listConsumers

          java.lang.String listConsumers​(java.lang.String options,
                                         int page,
                                         int pageSize)
                                  throws java.lang.Exception

      Throws:
        `java.lang.Exception`

    - #### listProducers

          java.lang.String listProducers​(java.lang.String options,
                                         int page,
                                         int pageSize)
                                  throws java.lang.Exception

      Throws:
        `java.lang.Exception`

    - #### listAddresses

          java.lang.String listAddresses​(java.lang.String options,
                                         int page,
                                         int pageSize)
                                  throws java.lang.Exception

      Throws:
        `java.lang.Exception`

    - #### listQueues

          java.lang.String listQueues​(java.lang.String options,
                                      int page,
                                      int pageSize)
                               throws java.lang.Exception

      Throws:
        `java.lang.Exception`

    - #### getQueueNames

          java.lang.String[] getQueueNames​(java.lang.String routingType)

      Returns the names of the queues created on this server with the given routing-type.

    - #### getClusterConnectionNames

          java.lang.String[] getClusterConnectionNames()

      Returns the names of the cluster-connections deployed on this server.

    - #### addUser

          void addUser​(java.lang.String username,
                       java.lang.String password,
                       java.lang.String roles,
                       boolean plaintext)
                throws java.lang.Exception

      Add a user (only applicable when using the JAAS PropertiesLoginModule or the ActiveMQBasicSecurityManager)
      Parameters:
        `username` -
        `password` -
        `roles` -
      Throws:
        `java.lang.Exception`

    - #### listUser

          java.lang.String listUser​(java.lang.String username)
                             throws java.lang.Exception

      List the information about a user or all users if no username is supplied (only applicable when using the JAAS PropertiesLoginModule or the ActiveMQBasicSecurityManager).
      Parameters:
        `username` -
      Returns:
        JSON array of user and role information
      Throws:
        `java.lang.Exception`

    - #### removeUser

          void removeUser​(java.lang.String username)
                   throws java.lang.Exception

      Remove a user (only applicable when using the JAAS PropertiesLoginModule or the ActiveMQBasicSecurityManager).
      Parameters:
        `username` -
      Throws:
        `java.lang.Exception`

    - #### resetUser

          void resetUser​(java.lang.String username,
                         java.lang.String password,
                         java.lang.String roles)
                  throws java.lang.Exception

      Set new properties on an existing user (only applicable when using the JAAS PropertiesLoginModule or the ActiveMQBasicSecurityManager).
      Parameters:
        `username` -
        `password` -
        `roles` -
      Throws:
        `java.lang.Exception`

    - #### resetUser

          void resetUser​(java.lang.String username,
                         java.lang.String password,
                         java.lang.String roles,
                         boolean plaintext)
                  throws java.lang.Exception

      Set new properties on an existing user (only applicable when using the JAAS PropertiesLoginModule or the ActiveMQBasicSecurityManager).
      Parameters:
        `username` -
        `password` -
        `roles` -
        `plaintext` -
      Throws:
        `java.lang.Exception`

    - #### reloadConfigurationFile

          void reloadConfigurationFile()
                                throws java.lang.Exception

      Throws:
        `java.lang.Exception`

    - #### replay

          void replay​(java.lang.String address,
                      java.lang.String target,
                      java.lang.String filter)
               throws java.lang.Exception

      Throws:
        `java.lang.Exception`

    - #### replay

          void replay​(java.lang.String startScan,
                      java.lang.String endScan,
                      java.lang.String address,
                      java.lang.String target,
                      java.lang.String filter)
               throws java.lang.Exception

      Throws:
        `java.lang.Exception`

    - #### stopEmbeddedWebServer

          void stopEmbeddedWebServer()
                              throws java.lang.Exception

      Throws:
        `java.lang.Exception`

    - #### startEmbeddedWebServer

          void startEmbeddedWebServer()
                               throws java.lang.Exception

      Throws:
        `java.lang.Exception`

    - #### restartEmbeddedWebServer

          void restartEmbeddedWebServer()
                                 throws java.lang.Exception

      Throws:
        `java.lang.Exception`

    - #### restartEmbeddedWebServer

          void restartEmbeddedWebServer​(long timeout)
                                 throws java.lang.Exception

      Throws:
        `java.lang.Exception`

    - #### isEmbeddedWebServerStarted

          boolean isEmbeddedWebServerStarted()